<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:h="http://java.sun.com/jsf/html"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:rich="http://richfaces.org/rich"
                xmlns:a4j="http://richfaces.org/a4j" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form>
            <s:div id="globalDiv">
                <h1>#{messages['net.ihe.gazelle.transformation.ApplicationPreferences']}</h1>
                <ui:decorate template="/layout/panels/_panel_footer.xhtml">
                    <rich:dataTable value="#{applicationConfigurationManager.getAllPreferences()}" var="pref">
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.transformation.PreferenceName']}</ui:define>
                            <h:outputText value="#{pref.variable}" style="font-weight:bold;"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.transformation.PreferenceValue']}</ui:define>
                            <rich:inplaceInput value="#{pref.value}"
                                               defaultLabel="#{messages['net.ihe.gazelle.transformation.PreferenceValue']}"
                                               showControls="true" size="16">
                                <a4j:ajax event="change" render="globalDiv"
                                          listener="#{applicationConfigurationManager.savePreference(pref)}"/>
                            </rich:inplaceInput>
                        </g:column>
                    </rich:dataTable>
                    <ui:define name="panel_footer">
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.transformation.AddAPreference']}"
                                           actionListener="#{applicationConfigurationManager.createNewPreference()}"
                                           rendered="#{applicationConfigurationManager.preference == null}" render="globalDiv"
                                           styleClass="gzl-btn-blue"/>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.transformation.ResetSecurityPreferences']}"
                                           actionListener="#{applicationConfigurationManager.resetHttpHeaders()}"
                                           rendered="#{applicationConfigurationManager.preference == null}" render="globalDiv"
                                           styleClass="gzl-btn-orange"/>
                    </ui:define>
                </ui:decorate>
                <h:panelGroup rendered="#{applicationConfigurationManager.preference != null}">
                    <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                        <ui:define name="panel_title">
                            #{messages['net.ihe.gazelle.transformation.NewApplicationPreference']}
                        </ui:define>
                        <div class="form-horizontal">
                            <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                <ui:param name="id" value="preferenceName"/>
                                <ui:define name="label">
                                    <h:outputText value="#{messages['net.ihe.gazelle.transformation.PreferenceName']}"/>
                                </ui:define>
                                <h:inputText styleClass="form-control" id="preferenceName"
                                             value="#{applicationConfigurationManager.preference.variable}"/>
                            </s:decorate>
                            <s:decorate template="/layout/form/_form_field_horizontal_inline.xhtml">
                                <ui:param name="id" value="preferenceValue"/>
                                <ui:define name="label">
                                    <h:outputText value="#{messages['net.ihe.gazelle.transformation.Value']}"/>
                                </ui:define>
                                <h:inputText styleClass="form-control" id="preferenceValue"
                                             value="#{applicationConfigurationManager.preference.value}"/>
                            </s:decorate>
                        </div>
                        <ui:define name="panel_footer">
                            <a4j:commandButton value="#{messages['net.ihe.gazelle.transformation.Save']}"
                                               actionListener="#{applicationConfigurationManager.savePreference(applicationConfigurationManager.preference)}"
                                               render="globalDiv" styleClass="gzl-btn-green"/>
                        </ui:define>
                    </ui:decorate>
                </h:panelGroup>
            </s:div>
        </h:form>
    </ui:define>
</ui:composition>